using Gtk;
using Sqlite;

namespace Customer {
	/*
	* class Ancestor Member
	*/
	public class Customer:Gtk.Window {
		protected Gtk.Entry entryName;
		protected Gtk.Entry entrySurname;
		protected Gtk.Entry entryFunction;
		protected Gtk.Entry entryPhone;
		protected Gtk.Entry entryMail;
		protected Gtk.Entry entryAddress;
		protected Gtk.Entry entryZIPCode;
		protected Gtk.Entry entryTown;
		protected Gtk.Entry entryCountry;
		
		protected Gtk.Button buttonValidate;
		
		protected Sqlite.Database db;
		protected string errMsgDB;
		protected string nameDB;
		
		/* ht_data's field are : name, surname, function, phone, mail, address, zip_code, town, country */
		protected HashTable <string, string> ht_data;
		
		public void display_interface() {
			this.show_all();
		}
		
		public int save_Customer() {
			print("Nome de la base %s\n", this.nameDB);
			int result = Sqlite.Database.open (this.nameDB, out this.db);
			if (result != Sqlite.OK) {
				stderr.printf("Erreur : %d: %s\n", this.db.errcode(), this.db.errmsg());
				return -1;
			}
			var query = "INSERT INTO Customer (name, surname) VALUES ('"
								+ entryName.get_text() + "','"
								+ entrySurname.get_text()
								+	"')";
			print("Requete : %s\t DB = %s \n", query, this.nameDB);
			result = this.db.exec (query, null, out this.errMsgDB);
			if (result!=Sqlite.OK) {
				stderr.printf("Erreur: %s\n", this.errMsgDB);
				return -1;
			}
			print("Ok requete update\n");
			return 0;
		}
		
		public void set_name_db(string name_db) {
			this.nameDB = name_db;
		}
		
		public void create_interface_gtk() {
			this.title="Ajout d'un client";
			this.set_default_size(400, -1);
			this.set_resizable(false);
			this.delete_event.connect(hide_on_delete);
			
			Gtk.Label labelName = new Gtk.Label("Prénom : ");
			labelName.set_xalign(0);
			this.entryName = new Gtk.Entry();
			this.entryName.set_hexpand(true);

			Gtk.Label labelSurname = new Gtk.Label("Nom : ");
			labelSurname.set_xalign(0);
			this.entrySurname = new Gtk.Entry();
			this.entrySurname.set_hexpand(true);
			
			Gtk.Label labelFunction = new Gtk.Label("Fonction : ");
			labelFunction.set_xalign(0);
			this.entryFunction = new Gtk.Entry();
			this.entryFunction.set_hexpand(true);
			
			Gtk.Label labelPhone = new Gtk.Label("Téléphone : ");
			labelPhone.set_xalign(0);
			this.entryPhone = new Gtk.Entry();
			this.entryPhone.set_hexpand(true);
			
			Gtk.Label labelMail = new Gtk.Label("Mail : ");
			labelMail.set_xalign(0);
			this.entryMail = new Gtk.Entry();
			this.entryMail.set_hexpand(true);
			
			Gtk.Label labelAddress = new Gtk.Label("Adresse : ");
			labelAddress.set_xalign(0);
			this.entryAddress = new Gtk.Entry();
			this.entryAddress.set_hexpand(true);
			
			Gtk.Label labelZIPCode = new Gtk.Label("Code Postale : ");
			labelZIPCode.set_xalign(0);
			this.entryZIPCode = new Gtk.Entry();
			this.entryZIPCode.set_hexpand(true);
			
			Gtk.Label labelCountry = new Gtk.Label("Ville : ");
			labelCountry.set_xalign(0);
			this.entryCountry = new Gtk.Entry();
			this.entryCountry.set_hexpand(true);
			
			this.buttonValidate = new Gtk.Button.with_label("Valider");
			this.buttonValidate.clicked.connect( ()=> {
				this.save_Customer();
				this.hide();
			});
			
			//Grid
			Gtk.Grid grid = new Gtk.Grid();
			this.add(grid);
			grid.attach(labelName, 0, 0, 1, 1);
			grid.attach(entryName, 1, 0, 1, 1);
			grid.attach(labelSurname, 0, 1, 1, 1);
			grid.attach(entrySurname, 1, 1, 1, 1);
			grid.attach(labelFunction, 0, 2, 1, 1);
			grid.attach(entryFunction, 1, 2, 1, 1);
			grid.attach(labelPhone, 0, 3, 1, 1);
			grid.attach(entryPhone, 1, 3, 1, 1);
			grid.attach(labelMail, 0, 4, 1, 1);
			grid.attach(entryMail, 1, 4, 1, 1);
			grid.attach(labelAddress, 0, 5, 1, 1);
			grid.attach(entryAddress, 1, 5, 1, 1);
			grid.attach(labelZIPCode, 0, 6, 1, 1);
			grid.attach(entryZIPCode, 1, 6, 1, 1);
			grid.attach(labelCountry, 0, 7, 1, 1);
			grid.attach(entryCountry, 1, 7, 1, 1);
			grid.attach(buttonValidate, 1, 8, 1, 1);
		}
		
		public Customer() {
			this.ht_data = new HashTable <string, string> (str_hash, str_equal);
		}
	}//end class Customer
}//end namespace
