using Gtk;
using Sqlite;
using Customer;

namespace ListCustomer {
	public class ListCustomer: Gtk.Window {
		
		protected Sqlite.Database db;
		protected string errMsgDB;
		protected string nameDB;
		
		public string get_name_db() {
			return this.nameDB;
		}
		
		public ListCustomer() {
		}
	}//end class ListCustomer
	
	public class NewListCustomer: ListCustomer {
		private Gtk.FileChooserDialog saveDialog;
		
		public int create_table_list_customer() {
			// create table ListCustomer
			var query = "CREATE TABLE Customer (name TEXT, surname TEXT, function TEXT, creation_date TEXT, phone INTEGER, mail TEXT, address TEXT, ZIP_code INTEGER, town TEXT, country TEXT)";
			int result = this.db.exec(query, null, out errMsgDB);
			if (result != Sqlite.OK) {
				stderr.printf("Erreur: %s\n", errMsgDB);
				return -1;
			}
			print("Creation de la table Customer\n");
			return 0;
		}
		
		public int create_database(string name_db) {			
			print("Nom : %s\n", name_db);
			
			int result = Sqlite.Database.open (name_db, out this.db);
			if (result != Sqlite.OK) {
				stderr.printf("Erreur : %d: %s\n", this.db.errcode(), this.db.errmsg());
				return -1;
			}
			this.nameDB = name_db;
			print("nameDB=%s\n", this.nameDB);
			create_table_list_customer();
			
			return 0;
		}
		
		public bool save_dialog() {
			bool res=false;
			this.saveDialog = new Gtk.FileChooserDialog(
				"Entrez un nom de fichier", this as Gtk.Window,
				Gtk.FileChooserAction.SAVE,
				"_Cancel", Gtk.ResponseType.CANCEL,
				"_Enregistrer",
				Gtk.ResponseType.ACCEPT
				);
				
			this.saveDialog.set_current_name("ListCustomer.db");
				
				if (this.saveDialog.run() == Gtk.ResponseType.ACCEPT) {
					this.nameDB = this.saveDialog.get_current_folder().concat(
						"/" , this.saveDialog.get_current_name(),null);
					create_database(this.nameDB);
					res = true;
				}
				
				this.saveDialog.close();
				this.saveDialog.show();
				return res;
		}
		
		public NewListCustomer() {
			
		}
	}//end class NewListCustomer
	
	/*******************************************************
	 * Class Load List Customer
	 ******************************************************/
	public class LoadListCustomer: ListCustomer {
		private Gtk.FileChooserDialog openDialog;
		
		public int exec_get_list_customer(int n_columns, string[] values, string[] column_names) {
			print("surname: %s \t name: %s \n", values[0], values[1]);
			return 0;
		}
		
		public bool get_list_customer() {
			int result = Sqlite.Database.open(this.nameDB, out this.db);
			if (result != Sqlite.OK) {
				stderr.printf("Erreur ouverture: %d %s\n", this.db.errcode(), this.db.errmsg());
				return false;
			}
			var query = "SELECT * FROM customer ORDER BY surname";
			result = this.db.exec(query, exec_get_list_customer, out errMsgDB);
			if (result != Sqlite.OK) {
				stderr.printf("Erreur: %s\n", errMsgDB);
				return false;
			}
			return true;
		}
		
		public bool open_dialog() {
			bool res=false;
			this.openDialog = new Gtk.FileChooserDialog(
				"Ouverture d'un fichier", this as Gtk.Window,
				Gtk.FileChooserAction.OPEN,
				"_Cancel", Gtk.ResponseType.CANCEL,
				"_Ouvrir", Gtk.ResponseType.ACCEPT
			);
			
			if ( this.openDialog.run() == Gtk.ResponseType.ACCEPT ) {
				print("Ouverture fichier : %s\n", this.openDialog.get_filename());
				this.nameDB = this.openDialog.get_filename();
				res=true;
			}
			
			this.openDialog.close();
			this.openDialog.show();
			return res;
		}
	}//end class LoadListCustomer
	
	/*********************************************************
	 * Class List Box
	 *********************************************************/
	public class ListBox: Gtk.Box {
		private Sqlite.Database db;
		private string errMsgDB;
		private string nameDB;
		
		private Gtk.ListStore list_store;
		private Gtk.TreeView view;
		private Gtk.TreeIter iter;
		
		public string get_name_db() {
			return this.nameDB;
		}
		
		public int exec_get_list_customer(int n_columns, string[] values, string[] column_names) {
			print("surname: %s \t name: %s \n", values[0], values[1]);
			return 0;
		}
		
		public bool get_list_customer() {
			int result = Sqlite.Database.open(this.nameDB, out this.db);
			if (result != Sqlite.OK) {
				stderr.printf("Erreur ouverture: %d %s\n", this.db.errcode(), this.db.errmsg());
				return false;
			}
			var query = "SELECT * FROM customer ORDER BY surname";
			result = this.db.exec(query, exec_get_list_customer, out errMsgDB);
			if (result != Sqlite.OK) {
				stderr.printf("Erreur: %s\n", errMsgDB);
				return false;
			}
			return true;
		}
		
		public ListBox(string name_db) {
			this.list_store = new Gtk.ListStore(2, typeof(string), typeof(string));
			this.nameDB = name_db;
			
			this.view = new Gtk.TreeView.with_model(this.list_store);
			Gtk.CellRendererText cell = new Gtk.CellRendererText();
			this.view.insert_column_with_attributes(-1, "Nom", cell, "text", 0);
			this.view.insert_column_with_attributes(-1, "Prénom", cell, "text", 1);
			this.get_list_customer();
//			this.view.set_activate_on_single_click(true);

			var scroll = new Gtk.ScrolledWindow(null, null);
			scroll.set_min_content_width(150);
			scroll.add(this.view);
			
			var boxListCustomer = new Gtk.Box(Gtk.Orientation.HORIZONTAL, 10);
			boxListCustomer.pack_start(scroll, false, false, 5);
			this.add(boxListCustomer);
		}
	}//end class ListBox
}//end namespace ListCustomer
