using Gtk;
using Customer;
using ListCustomer;

public class Gui:Gtk.Window {
	private Gtk.MenuBar menuBar;
	private Gtk.Menu menuFile;
	private Gtk.MenuItem menuItemFile;
	private Gtk.MenuItem menuItemQuit;
	
	private Gtk.Menu menuCustomer;
	private Gtk.MenuItem menuItemCustomer;
	private Gtk.MenuItem menuItemNewListCustomer;
	private Gtk.MenuItem menuItemLoadListCustomer;
	private Gtk.MenuItem menuItemAddCustomer;
	
	private Gtk.Label labelInfo;
	
	private string nameDB;
	
	private ListCustomer.NewListCustomer newListCustomer;
	private Customer.Customer customer;
	private ListCustomer.ListBox listBox;
	private LoadListCustomer loadListCustomer;
	
	public Gui() {
		this.title="Test Customer";
		this.destroy.connect(Gtk.main_quit);
		
		newListCustomer = new ListCustomer.NewListCustomer();
		customer = new Customer.Customer();
		customer.create_interface_gtk();
		
		listBox = new ListCustomer.ListBox("ListCustomer.db");
		
		loadListCustomer = new LoadListCustomer();
		
		// MenuBar
		this.menuBar = new Gtk.MenuBar();
		
		//MenuFile
		this.menuFile = new Gtk.Menu();
		this.menuItemFile = new Gtk.MenuItem.with_label("Fichier");
		menuItemFile.set_submenu(this.menuFile);
		this.menuItemQuit = new Gtk.MenuItem.with_label("Quitter");
		menuFile.add(this.menuItemQuit);
		menuBar.add(menuItemFile);

		
		//MenuCustomer
		this.menuCustomer = new Gtk.Menu();
		this.menuItemCustomer = new Gtk.MenuItem.with_label("Gestion client");
		this.menuItemCustomer.set_submenu(this.menuCustomer);
		this.menuItemNewListCustomer = new Gtk.MenuItem.with_label("Créer une liste");
		this.menuCustomer.add(this.menuItemNewListCustomer);
		this.menuItemLoadListCustomer = new Gtk.MenuItem.with_label("Charger une liste");
		this.menuCustomer.add(this.menuItemLoadListCustomer);
		this.menuItemAddCustomer = new Gtk.MenuItem.with_label("Ajouter Client");
		this.menuCustomer.add(this.menuItemAddCustomer);
		
		menuBar.add(menuItemCustomer);
		
		//Label
		this.labelInfo = new Gtk.Label("Test du module client\nIl faut créer ou charger une BDD client au préalable.");
		
		//Signal connect
		this.menuItemQuit.activate.connect (Gtk.main_quit);
		this.menuItemNewListCustomer.activate.connect( () => {
			var res = this.newListCustomer.save_dialog();
			if ( res == true ) {
				this.nameDB = this.newListCustomer.get_name_db();
				customer.set_name_db(this.nameDB);
				this.labelInfo.set_text("Création d'une BDD\n"+this.nameDB);
			} else {
				this.labelInfo.set_text("Erreur dans la création de la BDD");
			}
		});
		this.menuItemLoadListCustomer.activate.connect( () => {
			loadListCustomer.open_dialog();
			this.nameDB = loadListCustomer.get_name_db();
			loadListCustomer.get_list_customer();
		});
		this.menuItemAddCustomer.activate.connect( () => {
//			this.customer.create_interface_gtk();
			this.customer.show_all();
		});
		
		//Box
		Gtk.Box mainBox = new Gtk.Box(Gtk.Orientation.VERTICAL, 0);
		mainBox.pack_start(this.menuBar, false, false, 0);
		mainBox.pack_start(this.labelInfo, false, false, 0);
		mainBox.pack_start(listBox, false, false, 0);
		this.add(mainBox);
	}
	
	public static int main(string[] args) {
		Gtk.init(ref args);
		var gui = new Gui();
		gui.show_all();
		Gtk.main();
		return 0;
	}
}
